module timer(clk,sp,lp,sg,lg,in,to);
input clk,in;
output sp,lp,sg,lg,to;

reg sp1,lp1,sg1,lg1,rst,in1,to;
wire [11:0] time1;
wire [4:0] tm;

 cntr c1(.clk(clk),.q(time1),.rst(rst));
 assign tm={time1[11],time1[10],time1[9],time1[8]};

 assign sp=sp1;
 assign lp=lp1;
 assign sg=sg1;
 assign lg=lg1;

 always @(posedge clk)
 begin
  
    if(time1>12'd2300)
     to=1;
    else to=0;    


   in1<=in;

   if(in1&~in)
   begin
     rst=1;
	if(tm>4'd2&&tm<4'd5)
	begin
	  sp1=1; lp1=0; 
	  sg1=0; lg1=0; 
	end
	else
	if(tm>4'd4&&tm<4'd8)
	begin
	  sp1=0; lp1=1; 
	  sg1=0; lg1=0; 
	end
	else
	begin
	   sp1=1; lp1=1; 
	   sg1=0; lg1=0; 
	end
    end
    else
    if(~in1&in)
    begin
     rst=1;
	if(tm>4'd2&&tm<4'd5)
	begin
	  sg1=1; lg1=0; 
	  sp1=0; lp1=0; 
	end
	else
	if(tm>4'd4&&tm<4'd8)
	begin
	  sg1=0; lg1=1; 
	  sp1=0; lp1=0; 
	end
	else
	begin
	   sg1=1; lg1=1; 
	   sp1=0; lp1=0; 
	end
    end
    else     
	rst=0;	    
  
 end

endmodule
