module top(clock,in,cs,sck,s0,rdy,ld,C,A,T);
           
input clock,in,cs,sck;
output ld,s0,rdy,T;

output [4:0] A;
output [5:0] C;

				   
wire clk;

reg rc5ready;

wire [13:0] rc5code;

 

  clock_divider cd1(.clock(clock),.clk(clk));
  rc5decoderII dec(.clk(clk),.in(in),.rdy(rdy),.rc5code(rc5code));
  assign ld=rdy; 
  assign C={rc5code[5],rc5code[4],rc5code[3],rc5code[2],rc5code[1],rc5code[0]};
  assign A={rc5code[10],rc5code[9],rc5code[8],rc5code[7],rc5code[6]};
  assign T=rc5code[11];

  spi_core spi1(.clk(clk),.cs(cs),.sck(sck),.s0(s0),.data(rc5code));


endmodule
