module top(clock,in,cs,sck,s0,rdy,ld,C,A,T);
           
input clock,in,cs,sck;
output ld,s0,rdy,T;

input [4:0] A;
output [5:0] C;
wire [4:0] rc5addr;
reg [5:0] C;
wire clk;
reg T,ready;
wire rdy;

wire [13:0] rc5code;

 

  clock_divider cd1(.clock(clock),.clk(clk));
  rc5decoder dec(.clk(clk),.in(in),.rdy(rdy),.rc5code(rc5code));  
  spi_core spi1(.clk(clk),.cs(cs),.sck(sck),.s0(s0),.data(rc5code));

  assign rc5addr={rc5code[10],rc5code[9],rc5code[8],rc5code[7],rc5code[6]};

  always @(posedge clk)
  begin
    if(rdy)
    begin
	  if(rc5addr==A)
	  begin
          C={rc5code[5],rc5code[4],rc5code[3],rc5code[2],rc5code[1],rc5code[0]};
		T=rc5code[11];
		ready=1;
	  end 
    end
    else ready=0;
  
  end

  //assign C=cmd;
  assign ld=ready;
  //assign T=Toggle;

endmodule
