module rc5decoder(clk,in,rdy,rc5code);
           
input clk,in;
output rdy;
output [13:0] rc5code;


//wire time_out;		

reg [13:0] rc5code;
reg rc5ready,in1,load,start,to,onair;
reg [13:0] rc5temp;
wire [10:0] qcntr;
reg [1:0] ecnt;


 
 cntr c1(.clk(clk),.load(load),.d(11'd1333),.q(qcntr));

 
   always @(posedge clk)
   begin
        in1<=in;
	   if((in1&~in)||(~in1&in))
	   begin
		 if(~start) 
		 begin
		  start=1'b1; onair=0;
		  rc5temp=14'd1; ecnt=0; rc5ready=0;
		 end
		 else ecnt=ecnt+1;
	 
	      if(~onair) 
		 begin 
		   load=1'b1; 
		   onair=1'b1;
		 end
		 //else load=0;

		 to=0;
	   end
	   else 
	   load=0;

        if(ecnt==2'b11)
	   begin
	    start=0; to=0;
	   end

	   if(qcntr==11'd0)
	   begin
          //load=1'b1; 

		onair=0; ecnt=0;
		if(~to)
		begin
		  to=1'b1;
		  if(start) rc5temp={rc5temp[12:0],in};
		end
		else 
		begin 
		  start=0; to=0; rc5ready=0;
		end    
	   end
	   //else load=0;

	   if(rc5temp[13]==1'b1)
	   begin
	    rc5code=rc5temp; rc5ready=1; start=0; 
	   end
       	
	 
   end
 
   assign rdy=rc5ready;

  
endmodule
