module mux(data,sel,out);
input [13:0] data;
input [3:0] sel;
output out;
reg out;

always @(sel or data)
begin
    case (sel)
     4'd0: out=data[13]; 
	4'd1: out=data[12];
	4'd2: out=data[11];
	4'd3: out=data[10];
	4'd4: out=data[9];
	4'd5: out=data[8];
	4'd6: out=data[7];
	4'd7: out=data[6];
	4'd8: out=data[5];
	4'd9: out=data[4];
	4'd10: out=data[3];
	4'd11: out=data[2];
	4'd12: out=data[1];
	4'd13: out=data[0];
	4'd14: out=0;
	4'd15: out=0;
    endcase

end

endmodule
